package ch.hslu.appe.gui;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowEvent;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;

import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTabbedPane;
import javax.swing.JTable;
import javax.swing.JTextField;
import javax.swing.border.EmptyBorder;
import javax.swing.event.ListSelectionEvent;
import javax.swing.event.ListSelectionListener;

import ch.hslu.appe.gui.model.OrderTableModel;
import ch.hslu.appe.gui.model.ProductTableModel;
import ch.hslu.appe.inventory.webservice.ProductDto;
import ch.hslu.appe.order.webservice.IllegalNameException_Exception;
import ch.hslu.appe.order.webservice.OrderDto;
import ch.hslu.appe.order.webservice.OrderException_Exception;
import ch.hslu.appe.order.webservice.OrderPositionDto;
import ch.hslu.appe.order.webservice.SOAPException_Exception;
import ch.hslu.appe.usermanagement.webservice.AddressDto;
import ch.hslu.appe.usermanagement.webservice.UserDto;
import ch.hslu.appe.webservice.consumer.UserManagementConsumerImpl;
import ch.hslu.appe.webservice.consumer.InventoryConsumerImpl;
import ch.hslu.appe.webservice.consumer.OrderConsumerImpl;

import java.awt.Insets;

import javax.swing.SwingConstants;
import javax.swing.event.ChangeListener;
import javax.swing.event.ChangeEvent;
import javax.xml.datatype.XMLGregorianCalendar;

/**
 * ProductOrder.
 */
public class productOrder extends JFrame {

    private static final long serialVersionUID = 1L;
    private final FlowLayout flowLayout;
    private final FlowLayout flowLayoutProductOrder;
    private final FlowLayout flowLayoutOrder;
    private final JButton buttonCancel;
    private final JButton buttonOK;
    private final JButton buttonSubmitOrder;
    private final JButton buttonToCustomer;
    private final JButton buttonSearchCustomer;
    private final JButton buttonToOrders;
    private final JButton buttonAcceptOrder;
    private final JComboBox comboBoxAmount;
    private final JPanel panelMain;
    private final JPanel panelBottomProductOrder;
    private final JPanel panelProductOrderMain;
    private final JPanel productOrder;
    private final JPanel customer;
    private final JLabel labelProductname;
    private final JLabel labelPrice;
    private final JLabel labelTotalPrice;
    private final JLabel labelAmount;
    private final JLabel labelCustomerId;
    private final JLabel labelSalutation;
    private final JLabel labelPrename;
    private final JLabel labelName;
    private final JLabel labelStreetBillingAddress;
    private final JLabel labelStreetDeliveryAddress;
    private final JLabel labelZIPBillingAddress;
    private final JLabel labelLocationBillingAddress;
    private final JLabel labelZIPDeliveryAddress;
    private final JLabel labelLocationDeliveryAddress;
    private final JLabel labelBillingAddress;
    private final JLabel labelDeliveryAddress;
    private final JScrollPane scrollPaneProductOrder;
    private final JScrollPane scrollPaneOrder;
    private final JTabbedPane tabbedPaneCustomer;
    private final JTable tableOrder;
    private final JTable tableProductOrder;
    private final JTextField textCustomerId;
    private final JTextField textName;
    private final JTextField textPrename;
    private final JTextField textPrice;
    private final JTextField textProductname;
    private final JTextField textSalutation;
    private final JTextField textStreetBillingAddress;
    private final JTextField textStreetDeliveryAddress;
    private final JTextField textTotalPrice;
    private final JTextField textZIPBillingAddress;
    private final JTextField textLocationBillingAddress;
    private final JTextField textZIPDeliveryAddress;
    private final JTextField textLocationDeliveryAddress;
    private final JPanel panelBottom;
    private final JPanel panelContent;
    private final JPanel order;
    private final JPanel panelBottomOrder;
    private final JPanel panelOrderMain;
    private static customerManagement customerManagementFrame;
    private OrderDto activeOrder;
    private final JTextField textProductnumber;
    private final ProductTableModel productTableModel;
    private final OrderTableModel orderTableModel;
    private final JComboBox<ch.hslu.appe.usermanagement.webservice.AddressDto> comboBoxBillingAddress;
    private final JComboBox<ch.hslu.appe.usermanagement.webservice.AddressDto> comboBoxDeliveryAddress;
    private ch.hslu.appe.usermanagement.webservice.UserDto user;
    private JButton buttonDeletePosition;
    private JLabel labelProductnumber;
    private JLabel labelMessageAfterAdd;
    private JLabel labelTextBeforeCount;
    private JLabel labelCountPositions;
    private JLabel labelDeliveryDateAfterOrder;
    private JLabel labelPriceTotalAfterOrder;
    private JLabel labelOrderDeliveryDate;
    private JLabel labelOrderTotalPrice;
    private int orderId;

    /**
     * Create the frame.
     */
    public productOrder() {

        try {
            activeOrder = OrderConsumerImpl.getInstance().getActiveOrder();

            if (activeOrder == null) {
                activeOrder = new OrderDto();
                orderId = OrderConsumerImpl.getInstance().createOrder(activeOrder);
                activeOrder.setNumber(orderId);
            }

        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim lesen der aktiven Bestellung aufgetreten!",
                    "ERROR", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalNameException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim auslesen des Benutzers aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }

        // General
        setTitle("Produktbestellung");
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(100, 100, 682, 470);
        addWindowListener(new java.awt.event.WindowAdapter() {
            @Override
            public void windowClosing(final WindowEvent winEvt) {
                try {
                    OrderConsumerImpl.getInstance().releaseOrder(activeOrder.getNumber());
                } catch (OrderException_Exception e) {
                    JOptionPane.showMessageDialog(null, "Bestellungen konnten nicht freigegeben werden!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                } catch (SOAPException_Exception e) {
                    JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                }
            }
        });
        panelMain = new JPanel();
        panelMain.setBorder(new EmptyBorder(5, 5, 5, 5));
        panelMain.setLayout(new BorderLayout(0, 0));
        setContentPane(panelMain);

        // Bottom design
        // Panel bottom
        panelBottom = new JPanel();
        flowLayout = (FlowLayout) panelBottom.getLayout();
        flowLayout.setAlignment(FlowLayout.RIGHT);
        panelMain.add(panelBottom, BorderLayout.SOUTH);

        // Cancel button
        buttonCancel = new JButton("Abbrechen");
        buttonCancel.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                try {
                    OrderConsumerImpl.getInstance().releaseOrder(activeOrder.getNumber());
                    setVisible(false);
                    dispose();
                } catch (OrderException_Exception e) {
                    JOptionPane.showMessageDialog(null, "Die Bestellungen konnten nicht freigegeben werden!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                } catch (SOAPException_Exception e) {
                    JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                }
            }
        });
        buttonCancel.setFont(new Font("Tahoma", Font.PLAIN, 11));
        panelBottom.add(buttonCancel);

        // OK button
        buttonOK = new JButton("OK");
        buttonOK.setFont(new Font("Tahoma", Font.PLAIN, 11));
        buttonOK.setPreferredSize(new Dimension(85, 23));
        panelBottom.add(buttonOK);

        // Content Panel
        panelContent = new JPanel();
        panelMain.add(panelContent, BorderLayout.CENTER);
        panelContent.setLayout(new BorderLayout(0, 0));

        // Main tabbedPane
        tabbedPaneCustomer = new JTabbedPane(JTabbedPane.TOP);
        tabbedPaneCustomer.addChangeListener(new ChangeListener() {
            public void stateChanged(final ChangeEvent arg0) {
                if (tabbedPaneCustomer.getSelectedIndex() == 2 && user != null) {
                    if (buttonAcceptOrder.isEnabled()) {
                        addCustomerToOrder();
                    }
                }
            }
        });
        panelContent.add(tabbedPaneCustomer, BorderLayout.CENTER);

        // Tab 1
        productOrder = new JPanel();
        tabbedPaneCustomer.addTab("Produktbestellung", null, productOrder, null);
        productOrder.setLayout(new BorderLayout(0, 0));

        // Tab 1: Main Panel
        panelProductOrderMain = new JPanel();
        productOrder.add(panelProductOrderMain, BorderLayout.CENTER);
        panelProductOrderMain.setLayout(null);

        // Tab 1: TextField productname
        textProductname = new JTextField();
        textProductname.setEditable(false);
        textProductname.setEnabled(false);
        textProductname.setBounds(138, 59, 142, 20);
        panelProductOrderMain.add(textProductname);
        textProductname.setColumns(10);

        // Tab 1: Label productname
        labelProductname = new JLabel("Produktname");
        labelProductname.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelProductname.setBounds(31, 62, 90, 14);
        panelProductOrderMain.add(labelProductname);

        // Tab 1: TextField price
        textPrice = new JTextField();
        textPrice.setEnabled(false);
        textPrice.setEditable(false);
        textPrice.setBounds(138, 102, 142, 20);
        panelProductOrderMain.add(textPrice);
        textPrice.setColumns(10);

        // Tab 1: Label price
        labelPrice = new JLabel("Einzelpreis");
        labelPrice.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelPrice.setBounds(31, 105, 90, 14);
        panelProductOrderMain.add(labelPrice);

        // Tab 1: TextField TotalPrice
        textTotalPrice = new JTextField();
        textTotalPrice.setEnabled(false);
        textTotalPrice.setEditable(false);
        textTotalPrice.setBounds(138, 181, 142, 20);
        panelProductOrderMain.add(textTotalPrice);
        textTotalPrice.setColumns(10);

        // Tab 1: Label TotalPrice
        labelTotalPrice = new JLabel("Gesamtpreis");
        labelTotalPrice.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelTotalPrice.setBounds(31, 184, 90, 14);
        panelProductOrderMain.add(labelTotalPrice);

        // Tab 1: ComboBox Amount
        comboBoxAmount = new JComboBox();
        comboBoxAmount.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(final ItemEvent arg0) {
                calcTotalPrice();
            }
        });
        comboBoxAmount.setBounds(138, 143, 142, 20);
        panelProductOrderMain.add(comboBoxAmount);

        // Tab 1: Label Amount
        labelAmount = new JLabel("Menge");
        labelAmount.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelAmount.setBounds(31, 146, 90, 14);
        panelProductOrderMain.add(labelAmount);

        // Tab 1: Button Submit
        buttonSubmitOrder = new JButton("Bestellung eintragen");
        buttonSubmitOrder.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                addPosition();
                orderTableModel.generateTableData(activeOrder);
                labelMessageAfterAdd.setText((comboBoxAmount.getSelectedIndex() + 1) + " Stück des Produktes '"
                        + textProductname.getText() + "' wurde hinzugefügt!");

                // calculate total price
                float totalPrice = 0.0f;

                for (OrderPositionDto item : activeOrder.getOrderPositions()) {
                    totalPrice += item.getPrice() * item.getAmount();
                }
                // total price
                labelOrderTotalPrice.setText(String.format("%.2f", round(totalPrice, 2)));
            }
        });
        buttonSubmitOrder.setFont(new Font("Tahoma", Font.PLAIN, 11));
        buttonSubmitOrder.setBounds(138, 232, 142, 23);
        panelProductOrderMain.add(buttonSubmitOrder);

        labelProductnumber = new JLabel("Nummer");
        labelProductnumber.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelProductnumber.setBounds(31, 22, 46, 14);
        panelProductOrderMain.add(labelProductnumber);

        textProductnumber = new JTextField();
        textProductnumber.setEnabled(false);
        textProductnumber.setEditable(false);
        textProductnumber.setColumns(10);
        textProductnumber.setBounds(138, 19, 142, 20);
        panelProductOrderMain.add(textProductnumber);

        labelMessageAfterAdd = new JLabel("");
        labelMessageAfterAdd.setFont(new Font("Tahoma", Font.PLAIN, 10));
        labelMessageAfterAdd.setBounds(31, 277, 280, 14);
        panelProductOrderMain.add(labelMessageAfterAdd);

        labelTextBeforeCount = new JLabel("Anzahl Bestelleinträge: ");
        labelTextBeforeCount.setFont(new Font("Tahoma", Font.PLAIN, 10));
        labelTextBeforeCount.setBounds(31, 302, 107, 14);
        panelProductOrderMain.add(labelTextBeforeCount);

        labelCountPositions = new JLabel("0");
        labelCountPositions.setHorizontalAlignment(SwingConstants.RIGHT);
        labelCountPositions.setHorizontalTextPosition(SwingConstants.LEADING);
        labelCountPositions.setFont(new Font("Tahoma", Font.PLAIN, 10));
        labelCountPositions.setBounds(138, 302, 18, 14);
        panelProductOrderMain.add(labelCountPositions);

        // Tab 1: Panel ProductOrder
        panelBottomProductOrder = new JPanel();
        flowLayoutProductOrder = (FlowLayout) panelBottomProductOrder.getLayout();
        flowLayoutProductOrder.setAlignment(FlowLayout.RIGHT);
        productOrder.add(panelBottomProductOrder, BorderLayout.SOUTH);

        buttonToCustomer = new JButton("Weiter zum Kunden");
        buttonToCustomer.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                tabbedPaneCustomer.setSelectedIndex(1);
            }
        });
        buttonToCustomer.setFont(new Font("Tahoma", Font.PLAIN, 11));
        panelBottomProductOrder.add(buttonToCustomer);

        productTableModel = new ProductTableModel();
        tableProductOrder = new JTable(productTableModel);
        tableProductOrder.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        tableProductOrder.setPreferredScrollableViewportSize(new Dimension(300, 70));
        tableProductOrder.setFillsViewportHeight(true);
        tableProductOrder.getSelectionModel().addListSelectionListener(new ListSelectionListener() {
            @Override
            public void valueChanged(final ListSelectionEvent e) {
                int id = (int) productTableModel.getValueAt(tableProductOrder.getSelectedRow(), 0);
                selectProduct(id);
            }
        });

        scrollPaneProductOrder = new JScrollPane(tableProductOrder);
        scrollPaneProductOrder.setPreferredSize(new Dimension(319, 105));

        productOrder.add(scrollPaneProductOrder, BorderLayout.WEST);

        customer = new JPanel();
        tabbedPaneCustomer.addTab("Kunde", null, customer, null);
        customer.setLayout(null);

        textCustomerId = new JTextField();
        textCustomerId.setEnabled(false);
        textCustomerId.setEditable(false);
        textCustomerId.setBounds(106, 29, 112, 20);
        customer.add(textCustomerId);
        textCustomerId.setColumns(10);

        textPrename = new JTextField();
        textPrename.setEnabled(false);
        textPrename.setEditable(false);
        textPrename.setBounds(106, 74, 112, 20);
        customer.add(textPrename);
        textPrename.setColumns(10);

        textSalutation = new JTextField();
        textSalutation.setEnabled(false);
        textSalutation.setEditable(false);
        textSalutation.setBounds(341, 29, 112, 20);
        customer.add(textSalutation);
        textSalutation.setColumns(10);

        textName = new JTextField();
        textName.setEnabled(false);
        textName.setEditable(false);
        textName.setBounds(341, 74, 112, 20);
        customer.add(textName);
        textName.setColumns(10);

        labelCustomerId = new JLabel("KundenNr.");
        labelCustomerId.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelCustomerId.setBounds(30, 32, 78, 14);
        customer.add(labelCustomerId);

        labelSalutation = new JLabel("Anrede");
        labelSalutation.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelSalutation.setBounds(276, 32, 46, 14);
        customer.add(labelSalutation);

        labelPrename = new JLabel("Vorname");
        labelPrename.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelPrename.setBounds(30, 77, 46, 14);
        customer.add(labelPrename);

        labelName = new JLabel("Nachname");
        labelName.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelName.setBounds(276, 77, 60, 14);
        customer.add(labelName);

        buttonSearchCustomer = new JButton("Kunde suchen");
        buttonSearchCustomer.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                // Instantiate Frame customerManagement
                customerManagementFrame = new customerManagement();
                customerManagementFrame.setDefaultCloseOperation(DISPOSE_ON_CLOSE);
                customerManagementFrame.setVisible(true);
                customerManagementFrame.addWindowListener(new java.awt.event.WindowAdapter() {
                    @Override
                    public void windowDeactivated(final WindowEvent winEvt) {
                        user = customerManagementFrame.getUser();
                        if (user != null) {
                            updateCustomer();
                        }
                    }
                });
            }
        });
        buttonSearchCustomer.setFont(new Font("Tahoma", Font.PLAIN, 11));
        buttonSearchCustomer.setBounds(507, 73, 112, 23);
        customer.add(buttonSearchCustomer);

        textStreetBillingAddress = new JTextField();
        textStreetBillingAddress.setEnabled(false);
        textStreetBillingAddress.setEditable(false);
        textStreetBillingAddress.setBounds(106, 222, 112, 20);
        customer.add(textStreetBillingAddress);
        textStreetBillingAddress.setColumns(10);

        textZIPBillingAddress = new JTextField();
        textZIPBillingAddress.setEnabled(false);
        textZIPBillingAddress.setEditable(false);
        textZIPBillingAddress.setBounds(106, 253, 46, 20);
        customer.add(textZIPBillingAddress);
        textZIPBillingAddress.setColumns(10);

        textLocationBillingAddress = new JTextField();
        textLocationBillingAddress.setEnabled(false);
        textLocationBillingAddress.setEditable(false);
        textLocationBillingAddress.setBounds(106, 284, 112, 20);
        customer.add(textLocationBillingAddress);
        textLocationBillingAddress.setColumns(10);

        textStreetDeliveryAddress = new JTextField();
        textStreetDeliveryAddress.setEnabled(false);
        textStreetDeliveryAddress.setEditable(false);
        textStreetDeliveryAddress.setBounds(352, 222, 112, 20);
        customer.add(textStreetDeliveryAddress);
        textStreetDeliveryAddress.setColumns(10);

        textZIPDeliveryAddress = new JTextField();
        textZIPDeliveryAddress.setEnabled(false);
        textZIPDeliveryAddress.setEditable(false);
        textZIPDeliveryAddress.setBounds(352, 253, 46, 20);
        customer.add(textZIPDeliveryAddress);
        textZIPDeliveryAddress.setColumns(10);

        textLocationDeliveryAddress = new JTextField();
        textLocationDeliveryAddress.setEnabled(false);
        textLocationDeliveryAddress.setEditable(false);
        textLocationDeliveryAddress.setBounds(352, 284, 112, 20);
        customer.add(textLocationDeliveryAddress);
        textLocationDeliveryAddress.setColumns(10);

        labelStreetBillingAddress = new JLabel("Strasse");
        labelStreetBillingAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelStreetBillingAddress.setBounds(30, 225, 46, 14);
        customer.add(labelStreetBillingAddress);

        labelStreetDeliveryAddress = new JLabel("Strasse");
        labelStreetDeliveryAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelStreetDeliveryAddress.setBounds(276, 225, 46, 14);
        customer.add(labelStreetDeliveryAddress);

        labelZIPBillingAddress = new JLabel("PLZ");
        labelZIPBillingAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelZIPBillingAddress.setBounds(30, 256, 46, 14);
        customer.add(labelZIPBillingAddress);

        labelLocationBillingAddress = new JLabel("Ort");
        labelLocationBillingAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelLocationBillingAddress.setBounds(30, 287, 46, 14);
        customer.add(labelLocationBillingAddress);

        labelZIPDeliveryAddress = new JLabel("PLZ");
        labelZIPDeliveryAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelZIPDeliveryAddress.setBounds(276, 256, 46, 14);
        customer.add(labelZIPDeliveryAddress);

        labelLocationDeliveryAddress = new JLabel("Ort");
        labelLocationDeliveryAddress.setFont(new Font("Tahoma", Font.PLAIN, 11));
        labelLocationDeliveryAddress.setBounds(276, 287, 46, 14);
        customer.add(labelLocationDeliveryAddress);

        labelBillingAddress = new JLabel("Rechnungsadresse");
        labelBillingAddress.setFont(new Font("Tahoma", Font.BOLD, 11));
        labelBillingAddress.setBounds(30, 162, 121, 14);
        customer.add(labelBillingAddress);

        labelDeliveryAddress = new JLabel("Lieferadresse");
        labelDeliveryAddress.setFont(new Font("Tahoma", Font.BOLD, 11));
        labelDeliveryAddress.setBounds(276, 162, 93, 14);
        customer.add(labelDeliveryAddress);

        buttonToOrders = new JButton("Zu den Bestellungen");
        buttonToOrders.setEnabled(false);
        buttonToOrders.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent arg0) {
                tabbedPaneCustomer.setSelectedIndex(2);
            }
        });
        buttonToOrders.setFont(new Font("Tahoma", Font.PLAIN, 11));
        buttonToOrders.setBounds(507, 305, 134, 23);
        customer.add(buttonToOrders);

        comboBoxBillingAddress = new JComboBox<ch.hslu.appe.usermanagement.webservice.AddressDto>();
        comboBoxBillingAddress.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(final ItemEvent arg0) {
                updateBillingAddress();
            }
        });
        comboBoxBillingAddress.setBounds(30, 187, 188, 20);
        customer.add(comboBoxBillingAddress);

        comboBoxDeliveryAddress = new JComboBox<ch.hslu.appe.usermanagement.webservice.AddressDto>();
        comboBoxDeliveryAddress.addItemListener(new ItemListener() {
            @Override
            public void itemStateChanged(final ItemEvent arg0) {
                updateDeliveryAddress();
            }
        });
        comboBoxDeliveryAddress.setBounds(276, 187, 188, 20);
        customer.add(comboBoxDeliveryAddress);

        order = new JPanel();
        tabbedPaneCustomer.addTab("Bestellung", null, order, null);
        order.setLayout(new BorderLayout(0, 0));

        panelBottomOrder = new JPanel();
        flowLayoutOrder = (FlowLayout) panelBottomOrder.getLayout();
        flowLayoutOrder.setAlignment(FlowLayout.RIGHT);
        order.add(panelBottomOrder, BorderLayout.SOUTH);

        buttonAcceptOrder = new JButton("Bestellung best\u00E4tigen");
        buttonAcceptOrder.setText("Bestellung bestätigen");
        buttonAcceptOrder.setEnabled(false);
        buttonAcceptOrder.addActionListener(new ActionListener() {
            @Override
            public void actionPerformed(final ActionEvent e) {
                if (buttonAcceptOrder.getText() == "Bestellung bestätigen") {
                    submitOrder();
                } else {
                    newOrder();
                }
            }
        });
        buttonAcceptOrder.setFont(new Font("Tahoma", Font.PLAIN, 11));
        panelBottomOrder.add(buttonAcceptOrder);

        orderTableModel = new OrderTableModel(activeOrder);
        tableOrder = new JTable(orderTableModel);
        tableOrder.setAutoResizeMode(JTable.AUTO_RESIZE_ALL_COLUMNS);
        tableOrder.setPreferredScrollableViewportSize(new Dimension(500, 140));
        tableOrder.setFillsViewportHeight(true);
        if (activeOrder != null) {
            orderTableModel.generateTableData(activeOrder);
        }

        scrollPaneOrder = new JScrollPane(tableOrder);
        scrollPaneOrder.setPreferredSize(new Dimension(519, 175));

        order.add(scrollPaneOrder, BorderLayout.NORTH);

        panelOrderMain = new JPanel();
        order.add(panelOrderMain, BorderLayout.CENTER);
        panelOrderMain.setLayout(null);

        buttonDeletePosition = new JButton("");
        buttonDeletePosition.addActionListener(new ActionListener() {
            public void actionPerformed(final ActionEvent e) {

                if (tableOrder.getSelectedRow() < activeOrder.getOrderPositions().size()) {
                    if (activeOrder.getOrderPositions().size() > 0) {
                        int positionNr = (int) orderTableModel.getValueAt(tableOrder.getSelectedRow(), 0);
                        deletePosition(positionNr);

                        // calculate total price
                        float totalPrice = 0.0f;

                        for (OrderPositionDto item : activeOrder.getOrderPositions()) {
                            totalPrice += item.getPrice() * item.getAmount();
                        }
                        // total price
                        labelOrderTotalPrice.setText(String.format("%.2f", round(totalPrice, 2)));

                        if (activeOrder.getOrderPositions().size() == 0) {
                            buttonAcceptOrder.setEnabled(false);
                        }
                    }
                }
            }
        });
        buttonDeletePosition.setIcon(new ImageIcon(this.getClass().getResource("../img/del_small.png")));
        buttonDeletePosition.setMargin(new Insets(0, 0, 0, 0));
        buttonDeletePosition.setContentAreaFilled(false);
        buttonDeletePosition.setBorderPainted(false);
        buttonDeletePosition.setBorder(null);
        buttonDeletePosition.setBounds(616, 11, 25, 25);
        panelOrderMain.add(buttonDeletePosition);

        labelDeliveryDateAfterOrder = new JLabel("Liefertermin:");
        labelDeliveryDateAfterOrder.setBounds(10, 56, 95, 14);
        panelOrderMain.add(labelDeliveryDateAfterOrder);

        labelPriceTotalAfterOrder = new JLabel("Preis Total:");
        labelPriceTotalAfterOrder.setBounds(10, 98, 80, 14);
        panelOrderMain.add(labelPriceTotalAfterOrder);

        labelOrderDeliveryDate = new JLabel("");
        labelOrderDeliveryDate.setBounds(100, 56, 192, 14);
        panelOrderMain.add(labelOrderDeliveryDate);

        labelOrderTotalPrice = new JLabel("");
        labelOrderTotalPrice.setBounds(100, 98, 192, 14);
        panelOrderMain.add(labelOrderTotalPrice);
    }

    /**
     * addCustomerToOrder.
     */
    private void addCustomerToOrder() {

        try {
            UserDto activeUser = new UserDto();
            activeUser.setId(user.getId());

            activeOrder.setCustomer(activeUser);
            activeOrder.setDeliverAddress((AddressDto) comboBoxDeliveryAddress.getSelectedItem());

            try {
                boolean updateSuccessfully = OrderConsumerImpl.getInstance().updateOrder(activeOrder);

                if (!updateSuccessfully) {
                    JOptionPane.showMessageDialog(null,
                            "Der Kunde konnte nicht zur aktiven Bestellung hinzugefügt werden!", "ERROR",
                            JOptionPane.ERROR_MESSAGE);
                }
            } catch (IllegalNameException_Exception e) {
                JOptionPane.showMessageDialog(null, "IllegalNameException aufgetreten!", "ERROR",
                        JOptionPane.ERROR_MESSAGE);
            }
        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(null, "NumberFormatException aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null,
                    "Es ist ein Fehler beim hinzufügen des Kunden zu aktiven Bestellung aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }

    }

    /**
     * addPosition.
     */
    private void addPosition() {
        try {
            OrderPositionDto position = new OrderPositionDto();
            position.setAmount(comboBoxAmount.getSelectedIndex() + 1);
            position.setProductNumber(Integer.parseInt(textProductnumber.getText()));
            float totalPrice = Float.parseFloat(textTotalPrice.getText());
            position.setPrice(round(totalPrice, 2));

            int positionNr = OrderConsumerImpl.getInstance().addPosition(activeOrder.getNumber(),
                    position.getProductNumber(), position.getAmount());

            if (positionNr > 0) {
                position.setPosition(positionNr);

                boolean addSuccessfully = activeOrder.getOrderPositions().add(position);
                if (addSuccessfully) {
                    labelCountPositions.setText(Integer.toString(positionNr));
                    buttonAcceptOrder.setEnabled(true);
                } else {
                    JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim hinzufügen der Position aufgetreten!",
                            "ERROR", JOptionPane.ERROR_MESSAGE);
                }
            } else {
                JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim hinzufügen der Position aufgetreten!",
                        "ERROR", JOptionPane.ERROR_MESSAGE);
            }
        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(null, "NumberFormatException aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim hinzufügen der Position aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }
    }

    /**
     * calcTotalPrice.
     */
    private void calcTotalPrice() {
        // round price
        float price = round(Float.parseFloat(textPrice.getText()), 2);

        // if price not null, calculate total price
        if (price != 0) {
            textTotalPrice.setText(String.format("%.2f", ((comboBoxAmount.getSelectedIndex() + 1) * price)));
        } else {
            textTotalPrice.setText("0.00");
        }
    }

    /**
     * fillComboBoxAddress.
     * @param activeUser activeUser
     */
    private void fillComboBoxAddress(final UserDto activeUser) {
        // If comboBox BillingAddress not empty then remove all Items
        if (comboBoxBillingAddress.getComponentCount() > 0) {
            comboBoxBillingAddress.removeAllItems();
        }

        // If comboBox DeliveryAddress not empty then remove all Items
        if (comboBoxDeliveryAddress.getComponentCount() > 0) {
            comboBoxDeliveryAddress.removeAllItems();
        }

        // If actiiveUser not null, fill comboBoxBillingAddress and comboBoxDeliveryAddress
        if (activeUser != null) {

            ArrayList<ch.hslu.appe.usermanagement.webservice.AddressDto> addresses = UserManagementConsumerImpl
                    .getInstance().getAddressesById(activeUser.getId());

            if (addresses == null) {
                return;
            }

            for (int index = 0; index < addresses.size(); index++) {
                comboBoxBillingAddress.addItem(addresses.get(index));
                comboBoxDeliveryAddress.addItem(addresses.get(index));
            }
        }
    }

    /**
     * FillComboBoxAmount.
     * @param count count Amount
     */
    private void fillComboBoxAmount(final int count) {
        if (comboBoxAmount.getComponentCount() > 0) {
            comboBoxAmount.removeAllItems();
        }

        for (int index = 1; index <= count; index++) {
            comboBoxAmount.addItem(index);
        }

        if (count > 0) {
            comboBoxAmount.setSelectedIndex(0);
        }
    }

    /**
     * Select Product.
     * @param productNumber productNumber
     */
    private void selectProduct(final int productNumber) {
        ProductDto product = InventoryConsumerImpl.getInstance().getProduct(productNumber);

        buttonSubmitOrder.setEnabled(true);
        textProductnumber.setText(Integer.toString(product.getNumber()));
        textProductname.setText(product.getProductname());
        float price = round(product.getPrice(), 2);
        textPrice.setText(String.format("%.2f", price));
        fillComboBoxAmount(product.getAmount());
        float totalPrice = round(product.getPrice(), 2);
        textTotalPrice.setText(String.format("%.2f", totalPrice));
        if (product.getAmount() == 0) {
            buttonSubmitOrder.setEnabled(false);
        }
    }

    /**
     * submitOrder.
     */
    private void submitOrder() {
        try {
            // submit order
            boolean successfully = OrderConsumerImpl.getInstance().submitOrder(activeOrder.getNumber());

            // message when submit was successfully
            if (successfully) {
                JOptionPane.showMessageDialog(null, "Besten Dank für Ihre Bestellung", "Bestellung",
                        JOptionPane.OK_CANCEL_OPTION);

                // calculate total price
                float totalPrice = 0.0f;

                for (OrderPositionDto item : activeOrder.getOrderPositions()) {
                    totalPrice += item.getPrice() * item.getAmount();
                }

                // show delivery date and total price
                OrderDto myOrder = OrderConsumerImpl.getInstance().getOrder(orderId);
                // labelOrderDeliveryDate.setText(myOrder.getDeliverDate().toString());
                // final SimpleDateFormat dt = new SimpleDateFormat("dd.mm.yyyy");
                // labelOrderDeliveryDate.setText(dt.format(myOrder.getDeliverDate()));
                final XMLGregorianCalendar deliverDate = myOrder.getDeliverDate();
                labelOrderDeliveryDate.setText(deliverDate.getDay() + "." + deliverDate.getMonth() + "."
                        + deliverDate.getYear());
                labelOrderTotalPrice.setText(String.format("%.2f", totalPrice));

                // change Button for new order
                buttonAcceptOrder.setText("NEUE Bestellung");
            } else {
                JOptionPane.showMessageDialog(null,
                        "Keine gültige Bestellung! Bitte kontrollieren Sie ihre Bestellpositionen!", "Bestellung",
                        JOptionPane.OK_CANCEL_OPTION);
            }
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler bei der Bestätigung der Bestellung aufgetreten!",
                    "ERROR", JOptionPane.ERROR_MESSAGE);
        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }
    }

    /**
     * updateBillingAddress.
     */
    private void updateBillingAddress() {
        ch.hslu.appe.usermanagement.webservice.AddressDto address = (ch.hslu.appe.usermanagement.webservice.AddressDto) comboBoxBillingAddress
                .getSelectedItem();

        textStreetBillingAddress.setText(address.getStreet());
        textZIPBillingAddress.setText(Integer.toString(address.getZipCode()));
        textLocationBillingAddress.setText(address.getPlace());
    }

    /**
     * updateCustomer.
     */
    private void updateCustomer() {
        if (user != null) {
            textCustomerId.setText(Integer.toString(user.getId()));
            textSalutation.setText(user.getSalutation());
            textPrename.setText(user.getPrename());
            textName.setText(user.getSurname());
            fillComboBoxAddress(user);
            buttonToOrders.setEnabled(true);
            buttonAcceptOrder.setEnabled(true);
        } else {
            textCustomerId.setText("");
            textSalutation.setText("");
            textPrename.setText("");
            textName.setText("");
            comboBoxBillingAddress.setSelectedIndex(0);
            comboBoxDeliveryAddress.setSelectedIndex(0);
            buttonToOrders.setEnabled(false);
            buttonAcceptOrder.setEnabled(false);
        }
    }

    /**
     * updateDeliveryAddress.
     */
    private void updateDeliveryAddress() {
        ch.hslu.appe.usermanagement.webservice.AddressDto address = (ch.hslu.appe.usermanagement.webservice.AddressDto) comboBoxDeliveryAddress
                .getSelectedItem();

        textStreetDeliveryAddress.setText(address.getStreet());
        textZIPDeliveryAddress.setText(Integer.toString(address.getZipCode()));
        textLocationDeliveryAddress.setText(address.getPlace());
    }

    /**
     * deletePosition.
     * @param positionNr positionNr
     */
    private void deletePosition(final int positionNr) {
        try {
            OrderConsumerImpl.getInstance().deletePosition(activeOrder.getNumber(), positionNr);
            OrderPositionDto position = null;

            for (OrderPositionDto item : activeOrder.getOrderPositions()) {
                if (item.getPosition() == positionNr) {
                    position = item;
                    break;
                }
            }

            if (position != null) {
                activeOrder.getOrderPositions().remove(position);
            }

            // Refresh AddressTable
            orderTableModel.generateTableData(activeOrder);
            tableOrder.repaint();

        } catch (NumberFormatException e) {
            JOptionPane.showMessageDialog(null, "NumberFormatException aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim löschen einer Position aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }
    }

    /**
     * round.
     * @param number number
     * @param decimalPlace decimalPlace
     * @return formated float
     */
    private float round(final float number, final int decimalPlace) {
        BigDecimal bd = new BigDecimal(number);
        bd = bd.setScale(decimalPlace, BigDecimal.ROUND_HALF_UP);
        return bd.floatValue();
    }

    /**
     * newOrder.
     */
    private void newOrder() {

        // create new order
        try {
            OrderConsumerImpl.getInstance().releaseOrder(activeOrder.getNumber());
            activeOrder = new OrderDto();
            orderId = OrderConsumerImpl.getInstance().createOrder(activeOrder);
        } catch (SOAPException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein SOAP-Fehler aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        } catch (OrderException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim erstellen einer neuen Bestellung aufgetreten!",
                    "ERROR", JOptionPane.ERROR_MESSAGE);
        } catch (IllegalNameException_Exception e) {
            JOptionPane.showMessageDialog(null, "Es ist ein Fehler beim auslesen des Benutzers aufgetreten!", "ERROR",
                    JOptionPane.ERROR_MESSAGE);
        }
        activeOrder.setNumber(orderId);

        // Select tab 1
        tabbedPaneCustomer.setSelectedIndex(0);

        // Refresh AddressTable
        orderTableModel.generateTableData(activeOrder);
        tableOrder.repaint();

        // reset messages
        labelMessageAfterAdd.setText("");
        labelCountPositions.setText("0");
        buttonAcceptOrder.setText("Bestellung bestätigen");
        labelOrderDeliveryDate.setText("");
        labelOrderTotalPrice.setText("");
    }
}
