package ch.hslu.appe.webservice.consumer;

import java.util.List;

import ch.hslu.appe.inventory.webservice.ProductDto;

/**
 * InventoryConsumer.
 */
public interface InventoryConsumer {

    /**
     * getActiveProducts.
     * @return List of ProductDtos
     */
    List<ProductDto> getActiveProducts();

    /**
     * getProduct.
     * @param productNumber productNumber
     * @return ProductDto
     */
    ProductDto getProduct(int productNumber);

    /**
     * getProducts.
     * @return list of productDTOs
     */
    List<ProductDto> getProducts();

    /**
     * productActive.
     * @param productNumber productNumber
     * @return active
     */
    boolean productActive(int productNumber);

    /**
     * productExists.
     * @param productNumber productNumber
     * @return exists
     */
    boolean productExists(int productNumber);
}
